C*
C* Copyright 2013 Howard Hughes Medical Institute.
C* All rights reserved.
C* Use is subject to Janelia Farm Research Campus Software Copyright 1.1
C* license terms ( http://license.janelia.org/license/jfrc_copyright_1_1.html )
C*
c -----------------------------------------------------------------
	SUBROUTINE A3D3(NSET,ISWITCH,NSAM,IRAD,RI,RREC,
     +           AMAGP,DATC,DATQ,CTFF,CTFS,ASUM,VSUM,PSUM,C3DF,KSUM,
     +           PHI,THETA,PSI,DSHX,DSHY,PRESA,PBC,BOFF,
     +           A3DF,A3DS,S3DF,S3DS,STD,D3DF,D3DS,V3DF,V3DS,VTD,
     +           NN1,MAXSET,SINCLUT,IRADA,IPAD,THETATR,IEWALD,C3DS,
     +           NSYM,ISYM,JSYM,SYMOP,NNSTAT,NKSUM,
     +           IFSC,IMP,OCC,SIG2N,NKSUM1,TTD1)
c -----------------------------------------------------------------
c         Put alternating particles into A3 or D3
c	  Used in LMAIN
c	  Calls PINSERT
c -----------------------------------------------------------------
	IMPLICIT NONE
	INTEGER NN1,PBC,IRAD,NSAM,ISWITCH,MAXSET,NSET,NNSTAT
	INTEGER KSUM(*),IPAD,IRADA,NSYM,ISYM(*),JSYM(*),IFSC
        INTEGER IEWALD,IMP
        INTEGER*8 NKSUM,NKSUM1(*)
	REAL RREC(*),AMAGP,DSHX,DSHY,BOFF,RI
	REAL S3DF(*),S3DS(*),SYMOP(3,3,*)
	REAL V3DF(*),V3DS(*),OCC,THETATR,ON
        REAL ASUM(*),VSUM(*),PSUM(*),SIG2N
	REAL PSI,THETA,PHI,PRESA,SINCLUT(*)
	DOUBLEPRECISION STD,VTD,TTD1(*)
	COMPLEX CTFF(*),CTFS(*)
	COMPLEX DATC(*),DATQ(*),C3DF(*)
        COMPLEX A3DF(*),A3DS(*)
        COMPLEX D3DF(*),D3DS(*),C3DS(*)
c -----------------------------------------------------------------

        ON=OCC/SIG2N
        IF (ISWITCH.EQ.0) THEN
          CALL PINSERT(NSAM,IRAD,RI,RREC(NSET),AMAGP,DATC,DATQ,
     +    CTFF,CTFS,A3DF,A3DS,S3DF,S3DS,A3DF,A3DS,S3DF,S3DS,
     +    STD,PHI,THETA,PSI,DSHX,DSHY,PRESA,PBC,BOFF,
     +    ASUM,VSUM,PSUM,C3DF,KSUM,1,SINCLUT,IRADA,IPAD,
     +    THETATR/AMAGP,IEWALD,C3DS,NSYM,ISYM,
     +    JSYM,SYMOP,NNSTAT,NKSUM,IMP,ON,NKSUM1,TTD1)
          IF (IFSC.LE.2) ISWITCH=1
        ELSE
          IF (IFSC.EQ.0)
     +    CALL PINSERT(NSAM,IRAD,RI,RREC(NSET),AMAGP,DATC,DATQ,
     +    CTFF,CTFS,D3DF,D3DS,V3DF,V3DS,D3DF,D3DS,V3DF,V3DS,
     +    VTD,PHI,THETA,PSI,DSHX,DSHY,PRESA,PBC,BOFF,
     +    ASUM,VSUM,PSUM,C3DF,KSUM,1,SINCLUT,IRADA,IPAD,
     +    THETATR/AMAGP,IEWALD,C3DS,NSYM,ISYM,
     +    JSYM,SYMOP,NNSTAT,NKSUM,IMP,ON,NKSUM1,TTD1)
          ISWITCH=0
        ENDIF
	RETURN
	END
